var ChangeRefererButton = {

	ID													: "{c71ff04d-f001-1fc1-1fc1-c71ff04df001}",
	STRING_PREFERENCE_ADDON								: "extensions.changerefererbutton.",
	STRING_PREFERENCE_ADDON_DELAY_TEMPORARY				: "delayTemporary",
	STRING_PREFERENCE_ADDON_ICONS						: "icons",
	STRING_PREFERENCE_ADDON_INITIAL_REFERER				: "initialReferer",
	STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR			: "showInStatusBar",
	STRING_PREFERENCE_NETWORK_HTTP						: "network.http.",
	STRING_PREFERENCE_NETWORK_HTTP_SEND_REFERER_HEADER	: "sendRefererHeader",
	STRING_PREFERENCES									: {STRING_PREFERENCE_ADDON: null, STRING_PREFERENCE_NETWORK_HTTP: null},
	timer												: null,
	isGecko2Plus										: null,

	change: function(evt) {
		if (evt.button != 2) {
			switch(this.getReferer()){
				case 0:
					return this.setReferer(1);
				case 1:
					return this.setReferer(2);
				case 2:
				default:
					return this.setReferer(0);
			}
		}
	},

	changeTemporarily: function(val) {
		this.setStringInitialReferer(this.getReferer().toString());
		this.setReferer(val);
		this.timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this.timer.initWithCallback(function() {ChangeRefererButton.resetInitialReferer(); }, this.getIntegerDelayTemporary(), Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},

	resetInitialReferer: function() {
		if (this.timer != null) {
			var initialReferer = this.getStringInitialReferer();
			if (initialReferer != "") {
				this.setReferer(initialReferer);
				this.setStringInitialReferer("");
			}
			this.timer = null;
		}
	},

	getPreferencesBranch: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	},

	getBooleanShowInStatusBar: function() {
		var pb = this.getPreferencesBranch();
		return (pb.getPrefType(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR) == pb.PREF_BOOL && pb.getBoolPref(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR));
	},

	getIntegerDelayTemporary: function() {
		var pb = this.getPreferencesBranch();
		return (pb.getPrefType(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_DELAY_TEMPORARY) == pb.PREF_INT && pb.getIntPref(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_DELAY_TEMPORARY));
	},

	setStringInitialReferer: function(ref) {
		this.getPreferencesBranch().setCharPref(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_INITIAL_REFERER, ref);
	},

	getStringInitialReferer: function() {
		var pb = this.getPreferencesBranch();
		return (pb.getPrefType(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_INITIAL_REFERER) == pb.PREF_STRING && pb.getCharPref(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_INITIAL_REFERER));
	},

	getIntegerIcons: function() {
		var pb = this.getPreferencesBranch();
		return (pb.getPrefType(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_ICONS) == pb.PREF_INT && pb.getIntPref(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_ICONS));
	},

	showInStatusBar: function() {
		var panel = document.getElementById("change-referer-button-statusbarpanel");
		if (panel) {
			panel.hidden = !this.getBooleanShowInStatusBar();
		}
	},
	
	changeIcon: function(name) {
		var icon = document.getElementById(name);
		if (icon) {
			icon.setAttribute("referer", this.getReferer().toString());
			icon.setAttribute("icons", this.getIntegerIcons().toString());
			icon.tooltipText = this.getString("changerefererbutton.tooltiptext") + ": " + this.getRefererText();
		}
	},

	changeIcons: function() {
		this.changeIcon("change-referer-button-toolbarbutton");
		this.changeIcon("change-referer-button-statusbarpanel-image");
		this.updateContextMenu();
	},

	updateContextMenu: function() {
		var b0 = true, b1 = true, b2 = true;
		if (this.getStringInitialReferer() == "") {
			switch(this.getReferer()){
				case 0:
					b1 = false, b2 = false;
					break;
				case 1:
					b0 = false, b2 = false;
					break;
				case 2:
				default:
					b0 = false, b1 = false;
					break;
			}
		}
		document.getElementById("change-referer-button-menuitem0").disabled = b0;
		document.getElementById("change-referer-button-menuitem1").disabled = b1;
		document.getElementById("change-referer-button-menuitem2").disabled = b2;
	},

	getReferer: function() {
		return this.getPreferencesBranch().getIntPref(this.STRING_PREFERENCE_NETWORK_HTTP + this.STRING_PREFERENCE_NETWORK_HTTP_SEND_REFERER_HEADER);
	},

	setReferer: function(ref) {
		this.getPreferencesBranch().setIntPref(this.STRING_PREFERENCE_NETWORK_HTTP + this.STRING_PREFERENCE_NETWORK_HTTP_SEND_REFERER_HEADER, ref);
	},

	getRefererText: function() {
		switch(this.getReferer()){
			case 0:
				return this.getString("changerefererbutton.tooltip0");
			case 1:
				return this.getString("changerefererbutton.tooltip1");
			case 2:
			default:
				return this.getString("changerefererbutton.tooltip2");
		}
	},

	_dragDropIcon: function(evt) {
		ChangeRefererButton.changeIcons();
	},

	init: function() {
		window.addEventListener("dragdrop", this._dragDropIcon, false);
		this.changeIcons();
		this.showInStatusBar();
	},

	uninit: function() {
		window.removeEventListener("dragdrop", this._dragDropIcon, false);
		this.resetInitialReferer();
	},

	getString: function(s) {
		var element = document.getElementById("strings_changerefererbutton");
		if (element) {
			try { return element.getString(s); } catch (e) {}
		}
		return "";
	},

	clearUserPreference: function(pref) {
		var pb = this.getPreferencesBranch();
		if (pb.prefHasUserValue(pref)) {
			pb.clearUserPref(pref);
		}
	},

	clearUserPreferences: function() {
		this.clearUserPreference(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_DELAY_TEMPORARY);
		this.clearUserPreference(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_ICONS);
		this.clearUserPreference(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_INITIAL_REFERER);
		this.clearUserPreference(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR);
	},

	getExtensionManagerWindow: function() {
		return (this.testGecko2Plus()) ? window : Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("Extension:Manager");
	},

	showOptions: function() {
		window.openDialog("chrome://changerefererbutton/content/options.xul", "", "chrome=yes,centerscreen,modal=yes");
	},

	testPreferencesHaveUserValue: function() {
		return (this.getPreferencesBranch().prefHasUserValue(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_DELAY_TEMPORARY) || this.getPreferencesBranch().prefHasUserValue(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_ICONS) || this.getPreferencesBranch().prefHasUserValue(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_INITIAL_REFERER) || this.getPreferencesBranch().prefHasUserValue(this.STRING_PREFERENCE_ADDON + this.STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR));
	},

	uninstall: function() {
		if (this.testPreferencesHaveUserValue()) {
			var params = {in: null, out: null};
			var win = this.getExtensionManagerWindow();

			if (win!=null && (win == window || win.opener == window)) {
				win.openDialog("chrome://changerefererbutton/content/uninstall.xul", "", "chrome=yes,centerscreen,modal=yes", params);

				if (params.out) {
					this.clearUserPreferences();
				}
			}
		}
	},

	testGecko2Plus: function() {
		function geckoGetRv() {
			if (navigator.product != 'Gecko') {
				return -1;
			}
			var rvValue = 0;
			var ua      = navigator.userAgent.toLowerCase();
			var rvStart = ua.indexOf('rv:');
			var rvEnd   = ua.indexOf(')', rvStart);
			var rv      = ua.substring(rvStart+3, rvEnd);
			var rvParts = rv.split('.');
			var exp     = 1;

			for (var i = 0; i < rvParts.length; i++) {
				var val = parseInt(rvParts[i]);
				rvValue += val / exp;
				exp *= 100;
			}
			return rvValue;
		}

		if (this.isGecko2Plus == null) {
			this.isGecko2Plus = geckoGetRv() >= 2;
		}
		return this.isGecko2Plus;
	},

	preferenceChanged: function(brch, nme) {
		switch (brch) {
			case this.STRING_PREFERENCE_ADDON:
				switch (nme) {
					case this.STRING_PREFERENCE_ADDON_ICONS:
						this.changeIcons();
						break;
					case this.STRING_PREFERENCE_ADDON_INITIAL_REFERER:
						this.updateContextMenu();
						break;
					case this.STRING_PREFERENCE_ADDON_SHOW_IN_STATUS_BAR:
						this.showInStatusBar();
						break;
				}
				break;
			case this.STRING_PREFERENCE_NETWORK_HTTP:
				if (nme == this.STRING_PREFERENCE_NETWORK_HTTP_SEND_REFERER_HEADER) {
					this.changeIcons();
				}
				break;
		}
	},

	getId: function() {
		return this.ID;
	},

	getPreferences: function() {
		return this.STRING_PREFERENCES;
	},
}

var ChangeRefererButtonListeners = {
	mainAddon: null,
	preferencesListeners: [],
	uninstallListener: null,
	uninstallObserver: null,

	initPreferencesListeners: function() {
		function PreferencesListener(addon, branchName, func) {
			var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(branchName);
			branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

			this.register = function() {
				branch.addObserver("", this, false);
			};

			this.unregister = function unregister() {
				if (branch) {
					branch.removeObserver("", this);
				}
			};

			this.observe = function(subject, topic, data) {
				if (topic == "nsPref:changed") {
					func.call(addon, branchName, data);
				}
			};
		}

		for (var i in this.mainAddon.getPreferences()) {
			var preferencesListener = new PreferencesListener(this.mainAddon, this.mainAddon[i], this.mainAddon.preferenceChanged);
			preferencesListener.register();
			this.preferencesListeners.push(preferencesListener);
		}
	},

	initUninstallListenerOrObserver: function() {
		if (this.mainAddon.testGecko2Plus()) {
			this.uninstallListener = {
				mainAddon: this.mainAddon,

				onUninstalling: function(addon) {
					if (addon.id == this.mainAddon.getId()) {
						this.mainAddon.uninstall();
					}
				},
			}

			try {
				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				AddonManager.addAddonListener(this.uninstallListener);
			} catch (ex) {}
		} else {
			function UninstallObserver(addon) {
				this.mainAddon = addon;

				this.register = function() {
					Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).addObserver(this, "em-action-requested", false);
				};

				this.unregister = function() {
					Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).removeObserver(this, "em-action-requested");
				};

				this.observe = function(subject, topic, data) {
					if (subject.QueryInterface(Components.interfaces.nsIUpdateItem).id == this.mainAddon.getId()) {
						if (data == "item-uninstalled") {
							this.mainAddon.uninstall();
						}
					}
				};
			}

			this.uninstallObserver = new UninstallObserver(this.mainAddon);
			this.uninstallObserver.register();
		}
	},

	init: function(addon) {
		this.mainAddon = addon;
		this.initPreferencesListeners();
		this.initUninstallListenerOrObserver();
	},
}

ChangeRefererButtonListeners.init(ChangeRefererButton);